/*
 *  ArijaSoftGridView.h
 *  simpleLibApp
 *
 *  Created by atest try on 1/23/10.
 *  Copyright 2010 Arijasoft. All rights reserved.
 *
 */

#import <UIKit/UIKit.h>
#import <Foundation/Foundation.h>

@protocol GridViewDelegate;


@interface GridView : UIViewController <UIScrollViewDelegate> {
	id <GridViewDelegate> delegate;
	
    UIScrollView *scrollView;
    UIPageControl *pageControl;
    NSMutableArray *viewControllers;
    // To be used when scrolls originate from the UIPageControl
    BOOL pageControlUsed;
	
	
}


@property (nonatomic, assign) id <GridViewDelegate> delegate;
@property (nonatomic, retain) UIScrollView *scrollView;
@property (nonatomic, retain) UIPageControl *pageControl;
@property (nonatomic, retain) NSMutableArray *viewControllers;

- (void)changePage:(id)sender;


@end

@protocol GridViewDelegate

// delegate to return the number of pages in the View
-(NSInteger)numberOfPages;  

//delegate returns the Array of ScrollViewButton Objects for that page
-(NSArray *)ScrollButtonsforPage:(NSInteger)page; 

//delegate method to be implemented when user clicks on scrollViewButton
-(void)didSelectScrollButton:(id)identfier;


@end
typedef enum{
	ScrollViewButtonTypeFile = 0, //Loads from Resources
	ScrollViewButtonTypeUrl, //Loads from URL
}ScrollViewButtonType;

@interface ScrollViewButton : NSObject  {
	NSString *imageLocation;  //String can be the name of the image or the url
	
	NSString *bottomLabel;   //Label that appears at the bottom of the button
	
	NSInteger identifier;   //unique identifier that is set to identify the button
	//its the developer's responsibility to make this unique
	
	UIImage *btnImg;		//Background img data of the button
	//This can be accessed if the developer wants to change the btnImg
	
	ScrollViewButtonType bType; //Button type can be fromFile and url
	
	NSString *placeHolderImgName; //Defaults to Placeholder.png. Change this to any name 
	// to put as a placeholder image for url type of buttons.
	
	
}
@property(nonatomic retain)NSString *imageLocation;
@property(nonatomic retain)NSString *bottomLabel;
@property(nonatomic readwrite)NSInteger identifier;
@property(nonatomic retain) UIImage *btnImg;
@property(nonatomic readonly)ScrollViewButtonType bType;
@property(nonatomic retain) NSString *placeHolderImgName;


//Initialization function to be used for ScrollViewButton.
//NOTE: Each scrollViewButton has to be initialized with this function only.
//Otherwise it will not be able to function properly.

- (id)initWithIdentifier:(NSInteger)tag andLabel:(NSString*)btLabel ofImage:(NSString*)imageLoc withType:(ScrollViewButtonType)btnType;

@end

